# I3DExVertexPrimitive Struct Reference
[External Interfaces]

Inheritance diagram for I3DExVertexPrimitive:

List of all members.

## Public Member Functions
virtual void MCCOMAPI | Hydrate ()=0
virtual void MCCOMAPI | Dehydrate ()=0
virtual int32 MCCOMAPI | GetNbPolymeshes ()=0
virtual int32 MCCOMAPI | GetNbEdges ()=0
virtual int32 MCCOMAPI | GetNbPolygons ()=0
virtual void MCCOMAPI | GetPolymesh (IPolymesh **polymesh, int32 index)=0
virtual void MCCOMAPI | GetBoundingBox (TBBox3D &bbox, boolean ignoreSkining, boolean selection=false)=0
virtual void MCCOMAPI | GetUVBoundingBox (TBBox2D &bbox, boolean selection=false)=0
virtual int32 MCCOMAPI | Pick (void **obj, int32 flags, FatRay &fatRay, TVector3 &hitPosition)=0
virtual int32 MCCOMAPI | PickUV (void **obj, TIndex2 &index, const TVector2 &position, real32 raySize)=0
virtual void MCCOMAPI | DeleteSelectedEdges ()=0
virtual void MCCOMAPI | DeleteSelectedVertices (boolean useSymmetry)=0
virtual void MCCOMAPI | DeleteSelectedPolygons (boolean useSymmetry)=0
virtual IPolymesh *MCCOMAPI | CreatePolyhedra (int32 numPolygons, TBBox3D *bbox)=0
virtual IPolymesh *MCCOMAPI | CreateSphere (int32 circumferenceCount, int32 halfSectionCount, TBBox3D *bbox, CoordAxes axis)=0
virtual IPolymesh *MCCOMAPI | CreateCone (int32 baseSegmentCount, int32 heightSegmentCount, TBBox3D *bbox, CoordAxes axis)=0
virtual IPolymesh *MCCOMAPI | CreateCylinder (int32 numPolygons, int32 numSegments, TBBox3D *bbox, CoordAxes axis)=0
virtual IPolymesh *MCCOMAPI | CreateCube (TBBox3D *bbox, int32 segmentation)=0
virtual IPolymesh *MCCOMAPI | CreateMesh (int32 numU, int32 numV, CoordAxes uAxis, CoordAxes vAxis, real du, real dv, TVector3 &center, boolean crease=false)=0
virtual IPolymesh *MCCOMAPI | CreateMesh2 (int32 numU, int32 numV, const TVector3 &uAxis, const TVector3 &vAxis, real du, real dv, const TVector3 &center)=0
virtual IPolymesh *MCCOMAPI | CreateOval (CoordAxes uAxis, CoordAxes vAxis, real uSize, real vSize, int32 numSides, TVector3 &center)=0
virtual void MCCOMAPI | Triangulate ()=0
virtual void MCCOMAPI | Untriangulate ()=0
virtual void MCCOMAPI | CreatePolymesh (IPolymesh **iPolymesh)=0
virtual void MCCOMAPI | SetSphereOfAttraction (SSOAData &data)=0
virtual void MCCOMAPI | MoveSphereOfAttraction (TVector3 &center)=0
virtual void MCCOMAPI | DoneSphereOfAttraction ()=0
virtual void MCCOMAPI | DeleteAllPolymeshes (boolean clearShadingDomains)=0
virtual void MCCOMAPI | AddPolymesh (IPolymesh *polymesh)=0
virtual ErrorCode MCCOMAPI | Extrude (EExtrudeMode mode)=0
virtual ErrorCode MCCOMAPI | Sweep ()=0
virtual ErrorCode MCCOMAPI | Loft ()=0
virtual ErrorCode MCCOMAPI | Organic ()=0
virtual void MCCOMAPI | CreaseEdges (boolean byAngle, real angle, boolean includeNonSelectedEdges)=0
virtual void MCCOMAPI | SmoothEdges (boolean byAngle, real angle, boolean includeNonSelectedEdges)=0
virtual void MCCOMAPI | InitMarquee ()=0
virtual boolean MCCOMAPI | SetMarquee (TMCArray< RayPlane > &rayPlanes, int32 marqueeMode)=0
virtual boolean MCCOMAPI | SetUVMarquee (const TBBox2D &rect, int32 marqueeMode)=0
virtual void MCCOMAPI | EndMarquee ()=0
virtual void MCCOMAPI | ProjectToPlane (TVector3 &position, TVector3 &normal)=0
virtual void MCCOMAPI | OffsetSelection (TVector3 &offset)=0
virtual void MCCOMAPI | SubdivideSelection ()=0
virtual void MCCOMAPI | TesselateSelection (const ETesselateMode mode)=0
virtual boolean MCCOMAPI | CanPerform (int32 command)=0
virtual I3DExVertex *MCCOMAPI | SpecialVertex (boolean displayedOne=true)=0
virtual void MCCOMAPI | RemoveSpecialVertex (boolean displayedOne=true)=0
virtual void MCCOMAPI | ForAllVertices (IVertexCallback *callback)=0
virtual boolean MCCOMAPI | Weld (real tolerance, boolean alignOnly)=0
virtual void MCCOMAPI | AddThickness (real thickness)=0
virtual void MCCOMAPI | OffsetSurface (real distance)=0
virtual boolean MCCOMAPI | GetBestPlane (TVector3 &ii, TVector3 &jj, TVector3 &kk, TVector3 &center)=0
virtual ErrorCode MCCOMAPI | SimpleExtrude (real distance, boolean linkPolygons)=0
virtual IPolymesh *MCCOMAPI | PrepareRevolution ()=0
virtual IPolymesh *MCCOMAPI | Revolution (int32 nSteps, real32 tolerance)=0
virtual void MCCOMAPI | DirectNormalsOutward ()=0
virtual boolean MCCOMAPI | IsNewPrimitive ()=0
virtual void MCCOMAPI | StorePMAP (const VMDataStruct &data)=0
virtual void MCCOMAPI | GetPMAP (VMDataStruct &data)=0
virtual void MCCOMAPI | SetBackdropImage (const TMCString &filePath, uint16 planeID)=0
virtual void MCCOMAPI | ActivateBackdrop (boolean active, uint16 planeID)=0
virtual void MCCOMAPI | GetBackdropImage (TMCString &filePath, boolean &active, uint16 planeID)=0
virtual void MCCOMAPI | GetWorkingBoxInfo (TWorkingBoxInfo &outInfo) const =0
virtual void MCCOMAPI | SetWorkingBoxInfo (const TWorkingBoxInfo &inInfo)=0
virtual MCCOMErr MCCOMAPI | GetFacetMesh (uint32 lodindex, boolean faceted, EFacetMeshType meshType, FacetMesh **outMesh)=0
virtual MCCOMErr MCCOMAPI | GetFacetMesh2 (uint32 lodindex, FacetMesh **outMesh, boolean renderingMesh, EFacetMeshType meshType)=0
virtual void MCCOMAPI | GetModelerData (TBBox3D &bBox, TSegmentMesh &segmentMesh, TPointMesh &pointMesh, EFacetMeshType meshType, const TModelerDataFlags &modelerDataFlags)=0
virtual void MCCOMAPI | UpdatePolygonColors (FacetMesh *facetMesh, boolean faceted, EFacetMeshType meshType)=0
virtual boolean MCCOMAPI | HasRenderablePolygons ()=0
virtual boolean MCCOMAPI | HasRenderableEdges ()=0
virtual boolean MCCOMAPI | HasRenderableVertices ()=0
virtual IPolygon *MCCOMAPI | GetPolygonFromFacetIndex (int16 lodindex, int32 index)=0
virtual void MCCOMAPI | SetShowPolygons (boolean value)=0
virtual int32 MCCOMAPI | GetNbFacets ()=0
virtual int32 MCCOMAPI | GetNbVertices ()=0
virtual void MCCOMAPI | StartEdgeTransfer ()=0
virtual int32 MCCOMAPI | EdgeTransfer (EdgeData edgeBuffer[], int32 bufferSize)=0
virtual void MCCOMAPI | ExtensionDataChanged ()=0
virtual void MCCOMAPI | PreBoolean ()=0
virtual IPolymesh *MCCOMAPI | CurrentScriptPolymesh ()=0
virtual void MCCOMAPI | DetachPolygons ()=0
virtual void MCCOMAPI | ReverseSelectionNormals ()=0
virtual void MCCOMAPI | Decimate (real threshold, boolean decimateByValue, boolean distanceCriterion)=0
virtual void MCCOMAPI | Resize (TVector3 &scale)=0
virtual void MCCOMAPI | SetSize (TVector3 &scale)=0
virtual void MCCOMAPI | Rotate (real angle, CoordAxes axis)=0
virtual void MCCOMAPI | CenterAndResize (TVector3 &offset, real &scaleFactor)=0
virtual void MCCOMAPI | SetHidden (boolean value, ESelectType selectType)=0
virtual void MCCOMAPI | MakeVPAction (IVPAction::EVPActionKind kind, IVPAction **obj)=0
virtual void MCCOMAPI | SetSelection (boolean selected)=0
virtual void MCCOMAPI | InvertSelection (int32 selectionFlag)=0
virtual void MCCOMAPI | SetSelectionByName (boolean selected, int32 kind, int8 *name)=0
virtual void MCCOMAPI | SetSelectionByShadingDomain (int32 id, boolean select)=0
virtual void MCCOMAPI | GetNamesForKind (TMCArray< TMCString255 > &nameList, int32 kind)=0
virtual void MCCOMAPI | SetNameOnSelection (const TMCString &name, int32 kind)=0
virtual SVPStatus *MCCOMAPI | GetStatus ()=0
virtual void MCCOMAPI | Flatten ()=0
virtual void MCCOMAPI | Deform (I3DExModifier *deformer)=0
virtual MCCOMErr MCCOMAPI | DoImportFriend (I3DExVertexPrimitive *element, boolean select, int32 index, I3DShInstance *instance)=0
virtual MCCOMErr MCCOMAPI | DoExportFriend (I3DExVertexPrimitive *element, boolean select, int32 index, const TTransform3D &transform)=0
virtual MCCOMErr MCCOMAPI | DoImportAlien (IMCUnknown *element, real fidelity, boolean select, int32 index)=0
virtual IPolymesh *MCCOMAPI | BooleanOperation (int32 opKind, int32 iDA, int32 iDB)=0
virtual void MCCOMAPI | ResetPolymeshMarkers ()=0
virtual void MCCOMAPI | Flip (TVector3 &origin, TVector3 &normal)=0
virtual void MCCOMAPI | DuplicateWithSymmetry (TVector3 &origin, TVector3 &normal, real tolerance)=0
virtual void MCCOMAPI | DuplicateSelection ()=0
virtual ErrorCode MCCOMAPI | FillPolygons ()=0
virtual void MCCOMAPI | TimeHasChanged ()=0
| acts on selected polylines
virtual void MCCOMAPI | Replicate (SReplicate &data)=0
virtual void MCCOMAPI | PosCheck ()=0
virtual void MCCOMAPI | Adjust ()=0
virtual I3dExSkinable *MCCOMAPI | GetSkinableInterface ()=0
virtual void MCCOMAPI | GetSelectedSkinInfo (TMCClassArray< TVertexSkinInfo > &skinInfos)=0
virtual void MCCOMAPI | SetSelectedSkinInfo (TMCClassArray< TVertexSkinInfo > &skinInfos)=0
virtual void MCCOMAPI | SwapSkinInfos (TMCClassArray< TVertexSkinInfo > &skinInfos)=0
virtual void MCCOMAPI | SetSelectionShadingDomainID (uint32 ShadingDomainID)=0
virtual int32 MCCOMAPI | AddShadingDomain (TMCString &domainName, boolean clearFirst)=0
virtual void MCCOMAPI | RemoveShadingDomain (const int32 domainID, int32 replaceBy=-1)=0
virtual TMCClassArray < UVSpaceInfo > &MCCOMAPI | GetShadingDomainInfos ()=0
virtual const UVSpaceInfo *MCCOMAPI | GetUVSpaceInfoByID (uint32 uvSpaceID)=0
virtual void MCCOMAPI | CreateMorphAreaOnSelection (TMCString &morphAreaName, TMCArray< int32 > &removedAreas)=0
virtual void MCCOMAPI | SetMorphAreaOnSelection (const int32 morphAreaIndex, TMCArray< int32 > &removedAreas)=0
virtual int32 MCCOMAPI | CreateMetaMorphArea (const TMCString &morphAreaName, const TMCArray< int32 > &subAreas)=0
virtual int32 MCCOMAPI | GetMorphAreaCount ()=0
virtual IMorphArea *MCCOMAPI | GetMorphAreaNoAddRef (const int32 areaIndex)=0
virtual int32 MCCOMAPI | CreateMorphTarget (const int32 inMorphArea, TMCString &morphTargetName, const int32 inIndex=-1)=0
virtual boolean MCCOMAPI | RemoveMorphTarget (const int32 inMorphArea, const int32 targetIndex)=0
virtual void MCCOMAPI | SetSelectionByMorphArea (const int32 morphAreaIndex, const boolean select, const boolean addToCurrentSelection)=0
virtual void MCCOMAPI | RemoveMorphAreas (TMCArray< int32 > &removedAreaIndexes)=0
virtual EMorphMode MCCOMAPI | GetMorphMode (boolean &edit) const =0
| Gets the current morph mode.
virtual void MCCOMAPI | SetMorphMode (EMorphMode inMorphMode, boolean edit)=0
| Sets the current morph mode.
virtual const TMorphIDList *MCCOMAPI | GetEditedMorphs () const =0
| Gets the list of morphs being edited (returns null when not in edit mode).
virtual void MCCOMAPI | SetEditedMorphs (const TMorphIDList &inEditedMorphs)=0
| Sets the list of morphs being edited.
virtual void MCCOMAPI | ProjectEditedMorphFromSkinnedPosition ()=0
virtual void MCCOMAPI | AddOffsetFromTarget (const int32 inMorphArea, const int32 fromTarget, const int32 toTarget, const real32 coeff=1.0)=0
virtual boolean MCCOMAPI | ImportMorphTarget (I3DExVertexPrimitive *inSource, const TMorphIDList *morphIDList)=0
virtual boolean MCCOMAPI | ExportMorphTarget (I3DExVertexPrimitive *outObject, const TMorphIDList *morphIDList)=0
virtual void MCCOMAPI | InvalidateMorphing (const int32 areaIndex)=0
virtual void MCCOMAPI | GetMorphTargetUndoInfo (IMorphTargetUndoInfo **undoInfo, const int32 inMorphArea, const int32 inTargets)=0
virtual void MCCOMAPI | UndoMorphTargetChange (IMorphTargetUndoInfo *iUndoInfo)=0
virtual void MCCOMAPI | SetWorkingBoxPlane (IWorkingBoxPlane *WBPlane)=0
virtual void MCCOMAPI | SetSkinningAlgorithmComponent (IShComponent *algorithm)=0
virtual I3DExSkinningAlgorithm *MCCOMAPI | GetSkinningAlgorithm ()=0
virtual real32 MCCOMAPI | GetGlobalDeformerDefaultStrength (int32 deformerIndex)=0
virtual void MCCOMAPI | SetGlobalDeformerDefaultStrength (int32 deformerIndex, real32 strength)=0
virtual EMorphTargetStorageType MCCOMAPI | GetMorphTargetStorageType ()=0
virtual void MCCOMAPI | SetIsFigurePrimitive (boolean isFigurePrimitive)=0
virtual boolean MCCOMAPI | GetIsFigurePrimitive () const =0
virtual boolean MCCOMAPI | RayHit (const TVector3 &origin, const TVector3 &direction, TVector3 &position, TVector3 &normal, int32 &polymeshIndex)=0
virtual void MCCOMAPI | SymmetrizeSelection ()=0
virtual TVertexPrimSkinInfo *MCCOMAPI | ShouldApplySkinning (boolean &recomputeSkinning)=0
virtual boolean MCCOMAPI | CheckWrapConflict ()=0
virtual void MCCOMAPI | SkipWrapAlert ()=0
virtual void MCCOMAPI | SetUpdateFacetMeshColor (boolean enable)=0
virtual void MCCOMAPI | SetShowUVUnfoldInfoDifferentColor (boolean enable)=0
virtual real32 MCCOMAPI | GetScalingFactor () const =0
virtual boolean MCCOMAPI | IsHydrated () const =0
virtual void MCCOMAPI | SetSkinningValid (boolean valid)=0
| Invalidates the mesh (eg when the weights have changed.
virtual void MCCOMAPI | UnfoldUV (int32 projectionAxis, int32 uvPinningAxis)=0
virtual ILevelOfDetailsManager *MCCOMAPI | GetLODManager () const =0

## Detailed Description

I3DExVertexPrimitive is the main interface to access a vertex primitive. It can be useful if you want to export directly a vertex primitive (this allow to access the polygons data without having to go through triangulation).

You can query this interface (using QueryInterface) to know if a given primitive is a vertex primitive. If the primitive supports this interface it means that it is a vertex primitive.

## Member Function Documentation

virtual void MCCOMAPI I3DExVertexPrimitive::ActivateBackdrop | ( | boolean | active,
|  | uint16 | planeID |
| ) |  |  | `[pure virtual]`

Enable or disable a backdrop image on a plane

Parameters:

  | active | true if enabling
  | planeID | the id of the plane

virtual void MCCOMAPI I3DExVertexPrimitive::AddOffsetFromTarget | ( | const int32 | inMorphArea,
|  | const int32 | fromTarget,
|  | const int32 | toTarget,
|  | const real32 | coeff = `1.0` |
| ) |  |  | `[pure virtual]`

Add the offsets of a specific target to another one. This can be used to merge targets, or to copy the content of a target into another one.

Parameters:

  | inMorphArea | The id of the morph area concerned
  | fromTarget | The target source
  | toTarget | The destination target
  | coeff | Multiply all the offset of the target source before copiing them into the destination.

virtual void MCCOMAPI I3DExVertexPrimitive::AddPolymesh | ( | IPolymesh * | polymesh | ) | `[pure virtual]`

virtual int32 MCCOMAPI I3DExVertexPrimitive::AddShadingDomain | ( | TMCString & | domainName,
|  | boolean | clearFirst |
| ) |  |  | `[pure virtual]`

Adds a new shading domain to the list of shading domain of the primitive.

Parameters:

  | domainName | The name of the domain to be added
  | clearFirst | Sets this flag to true to remove the existing shading domain before adding the new one.

Returns:
  the ID of the new shading domain ( or of the already existing domain)

virtual void MCCOMAPI I3DExVertexPrimitive::AddThickness | ( | real | thickness | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::Adjust | ( |  | ) | `[pure virtual]`

virtual IPolymesh* MCCOMAPI I3DExVertexPrimitive::BooleanOperation | ( | int32 | opKind,
|  | int32 | iDA,
|  | int32 | iDB |
| ) |  |  | `[pure virtual]`

virtual boolean MCCOMAPI I3DExVertexPrimitive::CanPerform | ( | int32 | command | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::CenterAndResize | ( | TVector3 & | offset,
|  | real & | scaleFactor |
| ) |  |  | `[pure virtual]`

virtual boolean MCCOMAPI I3DExVertexPrimitive::CheckWrapConflict | ( |  | ) | `[pure virtual]`

Return true if PolymeshSet WrapAround have a conflict

virtual void MCCOMAPI I3DExVertexPrimitive::CreaseEdges | ( | boolean | byAngle,
|  | real | angle,
|  | boolean | includeNonSelectedEdges |
| ) |  |  | `[pure virtual]`

virtual IPolymesh* MCCOMAPI I3DExVertexPrimitive::CreateCone | ( | int32 | baseSegmentCount,
|  | int32 | heightSegmentCount,
|  | TBBox3D * | bbox,
|  | CoordAxes | axis |
| ) |  |  | `[pure virtual]`

Creates a cone.

Parameters:

  | baseSegmentCount | Number of edges arround the base.
  | heightSegmentCount | Number of section to the top.
  | bbox | The bounding box countaning the polyhedra.
  | axis | Axis of the cone.

Returns:
  A pointer on the created polymesh

virtual IPolymesh* MCCOMAPI I3DExVertexPrimitive::CreateCube | ( | TBBox3D * | bbox,
|  | int32 | segmentation |
| ) |  |  | `[pure virtual]`

Creates a cube.

Parameters:

  | bbox | The bounding box countaning the cube.
  | segmentation | Tesselation by face.

Returns:
  A pointer to the created polymesh.

virtual IPolymesh* MCCOMAPI I3DExVertexPrimitive::CreateCylinder | ( | int32 | numPolygons,
|  | int32 | numSegments,
|  | TBBox3D * | bbox,
|  | CoordAxes | axis |
| ) |  |  | `[pure virtual]`

Creates a cylinder

Parameters:

  | numPolygons | Number of edges arround the base
  | numSegments | Number of section to the top
  | bbox | The bounding box countaning the polyhedra
  | axis | Axis of the cylinder

Returns:
  A pointer to the created polymesh

virtual IPolymesh* MCCOMAPI I3DExVertexPrimitive::CreateMesh | ( | int32 | numU,
|  | int32 | numV,
|  | CoordAxes | uAxis,
|  | CoordAxes | vAxis,
|  | real | du,
|  | real | dv,
|  | TVector3 & | center,
|  | boolean | crease = `false` |
| ) |  |  | `[pure virtual]`

Creates a mesh (grid).

Parameters:

  | numU,: | number of section along u axis
  | numV,: | number of section along v axis
  | uAxis,: | X,Y or Z
  | vAxis,: | X,Y or Z
  | du,: | length of 1 section along u
  | dv,: | length of 1 section along v
  | center |
  | crease |

Returns:
  A pointer to the created polymesh

virtual IPolymesh* MCCOMAPI I3DExVertexPrimitive::CreateMesh2 | ( | int32 | numU,
|  | int32 | numV,
|  | const TVector3 & | uAxis,
|  | const TVector3 & | vAxis,
|  | real | du,
|  | real | dv,
|  | const TVector3 & | center |
| ) |  |  | `[pure virtual]`

virtual int32 MCCOMAPI I3DExVertexPrimitive::CreateMetaMorphArea | ( | const TMCString & | morphAreaName,
|  | const TMCArray< int32 > & | subAreas |
| ) |  |  | `[pure virtual]`

creates a new meta morph area and returns the index of the new morph area (or -1 if an error occured).

Parameters:

  | morphAreaName,: | the name of the new area.
  | subAreas,: | an array of the indexes of the sub areas linked to this new meta morph area.

virtual void MCCOMAPI I3DExVertexPrimitive::CreateMorphAreaOnSelection | ( | TMCString & | morphAreaName,
|  | TMCArray< int32 > & | removedAreas |
| ) |  |  | `[pure virtual]`

Create a new morph area on the current selection and set the passed name to it. If some vertices of the selection already had a morph area, the new one erase the old one. If in this process, an older morph area can be deprived of any vertices and become useless. In that case, they're not removed but their indexes are return so they can be easily removed later.

Parameters:

  | morphAreaName,: | the name of the new area.
  | removedAreas,: | an array of the indexes of the area that aren't used anymore by any vertex after the new one has been set.

virtual int32 MCCOMAPI I3DExVertexPrimitive::CreateMorphTarget | ( | const int32 | inMorphArea,
|  | TMCString & | morphTargetName,
|  | const int32 | inIndex = `-1` |
| ) |  |  | `[pure virtual]`

Creates a morph target in a specific morph area and set its name. All the vertices countain in the morph area have a default deformation set to a vector 0.

Parameters:

  | inMorphArea | The index of the area.
  | morphTargetName | The name of the new target.
  | inIndex | Where the new morph should be inserted in the list (-1 => at the end)

Returns:
  the index of the new morph target or -1 if the operation could not be performed.

virtual IPolymesh* MCCOMAPI I3DExVertexPrimitive::CreateOval | ( | CoordAxes | uAxis,
|  | CoordAxes | vAxis,
|  | real | uSize,
|  | real | vSize,
|  | int32 | numSides,
|  | TVector3 & | center |
| ) |  |  | `[pure virtual]`

Creates an oval.

Parameters:

  | uAxis | X,Y or Z
  | vAxis | X,Y or Z
  | uSize | size along u axis
  | vSize | size along v axis
  | numSides | number of edges arround the oval
  | center | center of the oval.

Returns:
  A pointer to the created polymesh

virtual IPolymesh* MCCOMAPI I3DExVertexPrimitive::CreatePolyhedra | ( | int32 | numPolygons,
|  | TBBox3D * | bbox |
| ) |  |  | `[pure virtual]`

Create a polyhedra based on one of this platonic polyhedron: tetrahedra (4 polygons), cube (6 polygons), octahedra (8 polygons), dodecahedra (12 polygons), icosahedron (20 polygons) and then subdived it

Parameters:

  | numPolygons | The number of polygons wanted ( this number might not be the number of polygons on the polyhedra: the polyhedra created will used the most suitable number for the number of polygons wanted )
  | bbox | The bounding box countaning the polyhedra

Returns:
  A pointer to the created polymesh

virtual void MCCOMAPI I3DExVertexPrimitive::CreatePolymesh | ( | IPolymesh ** | iPolymesh | ) | `[pure virtual]`

virtual IPolymesh* MCCOMAPI I3DExVertexPrimitive::CreateSphere | ( | int32 | circumferenceCount,
|  | int32 | halfSectionCount,
|  | TBBox3D * | bbox,
|  | CoordAxes | axis |
| ) |  |  | `[pure virtual]`

Creates a sphere.

Parameters:

  | circumferenceCount | Number of edges arround the sphere.
  | halfSectionCount | Number of section over and under the equador.
  | bbox | The bounding box countaning the sphere.
  | axis | Axis of the sphere.

Returns:
  A pointer to the created polymesh

virtual IPolymesh* MCCOMAPI I3DExVertexPrimitive::CurrentScriptPolymesh | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::Decimate | ( | real | threshold,
|  | boolean | decimateByValue,
|  | boolean | distanceCriterion |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::Deform | ( | I3DExModifier * | deformer | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::Dehydrate | ( |  | ) | `[pure virtual]`

Called by the modeler when it is dehydrated.

virtual void MCCOMAPI I3DExVertexPrimitive::DeleteAllPolymeshes | ( | boolean | clearShadingDomains | ) | `[pure virtual]`

Removes all the polymeshes from the primitive

Parameters:

  | clearShadingDomains | True to remove all the shading domains

virtual void MCCOMAPI I3DExVertexPrimitive::DeleteSelectedEdges | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::DeleteSelectedPolygons | ( | boolean | useSymmetry | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::DeleteSelectedVertices | ( | boolean | useSymmetry | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::DetachPolygons | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::DirectNormalsOutward | ( |  | ) | `[pure virtual]`

virtual MCCOMErr MCCOMAPI I3DExVertexPrimitive::DoExportFriend | ( | I3DExVertexPrimitive * | element,
|  | boolean | select,
|  | int32 | index,
|  | const TTransform3D & | transform |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI I3DExVertexPrimitive::DoImportAlien | ( | IMCUnknown * | element,
|  | real | fidelity,
|  | boolean | select,
|  | int32 | index |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI I3DExVertexPrimitive::DoImportFriend | ( | I3DExVertexPrimitive * | element,
|  | boolean | select,
|  | int32 | index,
|  | I3DShInstance * | instance |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::DoneSphereOfAttraction | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::DuplicateSelection | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::DuplicateWithSymmetry | ( | TVector3 & | origin,
|  | TVector3 & | normal,
|  | real | tolerance |
| ) |  |  | `[pure virtual]`

virtual int32 MCCOMAPI I3DExVertexPrimitive::EdgeTransfer | ( | EdgeData | edgeBuffer[],
|  | int32 | bufferSize |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::EndMarquee | ( |  | ) | `[pure virtual]`

virtual boolean MCCOMAPI I3DExVertexPrimitive::ExportMorphTarget | ( | I3DExVertexPrimitive * | outObject,
|  | const TMorphIDList * | morphIDList |
| ) |  |  | `[pure virtual]`

Export a morph target to antoher vertex object.

Parameters:

  | outObject | The object.
  | inMorphArea | The id of the morph area
  | inTarget | The id of the morph target

Returns:
  True if the operation could be performed

virtual void MCCOMAPI I3DExVertexPrimitive::ExtensionDataChanged | ( |  | ) | `[pure virtual]`

virtual ErrorCode MCCOMAPI I3DExVertexPrimitive::Extrude | ( | EExtrudeMode | mode | ) | `[pure virtual]`

virtual ErrorCode MCCOMAPI I3DExVertexPrimitive::FillPolygons | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::Flatten | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::Flip | ( | TVector3 & | origin,
|  | TVector3 & | normal |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::ForAllVertices | ( | IVertexCallback * | callback | ) | `[pure virtual]`

Call a callback on all vertices

virtual void MCCOMAPI I3DExVertexPrimitive::GetBackdropImage | ( | TMCString & | filePath,
|  | boolean & | active,
|  | uint16 | planeID |
| ) |  |  | `[pure virtual]`

Get the status of the backdrop image of a plane

Parameters:

  | filePath | return the full path of the image file
  | active | return true if the backdrop is enabled
  | planeID | the id of the plane

virtual boolean MCCOMAPI I3DExVertexPrimitive::GetBestPlane | ( | TVector3 & | ii,
|  | TVector3 & | jj,
|  | TVector3 & | kk,
|  | TVector3 & | center |
| ) |  |  | `[pure virtual]`

Returns the plane that is closest to the current selection

Parameters:

  | ii | First vector of the plane
  | jj | Second vector of the plane
  | kk | Vector normal to the plane
  | center | Point in the plane.

virtual void MCCOMAPI I3DExVertexPrimitive::GetBoundingBox | ( | TBBox3D & | bbox,
|  | boolean | ignoreSkining,
|  | boolean | selection = `false` |
| ) |  |  | `[pure virtual]`

Returns the bounding box of the vertex primitive. To get the bounding box of the selection, set selection to true.

Parameters:

  | ignoreSkining | False: return invalid bbox if skinned.
  | selection | Set to true to get the bounding box of the selection.
  | bbox | The bounding box of the primitive that is returned.

virtual const TMorphIDList* MCCOMAPI I3DExVertexPrimitive::GetEditedMorphs | ( |  | ) | const`[pure virtual]`

Gets the list of morphs being edited (returns null when not in edit mode).

virtual MCCOMErr MCCOMAPI I3DExVertexPrimitive::GetFacetMesh | ( | uint32 | lodindex,
|  | boolean | faceted,
|  | EFacetMeshType | meshType,
|  | FacetMesh ** | outMesh |
| ) |  |  | `[pure virtual]`

virtual MCCOMErr MCCOMAPI I3DExVertexPrimitive::GetFacetMesh2 | ( | uint32 | lodindex,
|  | FacetMesh ** | outMesh,
|  | boolean | renderingMesh,
|  | EFacetMeshType | meshType |
| ) |  |  | `[pure virtual]`

virtual real32 MCCOMAPI I3DExVertexPrimitive::GetGlobalDeformerDefaultStrength | ( | int32 | deformerIndex | ) | `[pure virtual]`

Gets the default strength of an attached global deformer. This strength can be overriden on a morph area.

virtual boolean MCCOMAPI I3DExVertexPrimitive::GetIsFigurePrimitive | ( |  | ) | const`[pure virtual]`

Returns true if a vertex primitive is actually a figure.

virtual ILevelOfDetailsManager* MCCOMAPI I3DExVertexPrimitive::GetLODManager | ( |  | ) | const`[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::GetModelerData | ( | TBBox3D & | bBox,
|  | TSegmentMesh & | segmentMesh,
|  | TPointMesh & | pointMesh,
|  | EFacetMeshType | meshType,
|  | const TModelerDataFlags & | modelerDataFlags |
| ) |  |  | `[pure virtual]`

Get the Edges and Vertexes colors, as well as their position and index, and the BBox of the polymeshSet

virtual int32 MCCOMAPI I3DExVertexPrimitive::GetMorphAreaCount | ( |  | ) | `[pure virtual]`

Returns the number of morph area in the primitive. Some of these areas can be empty ( not used by any of the vertices of the primitive )

virtual IMorphArea* MCCOMAPI I3DExVertexPrimitive::GetMorphAreaNoAddRef | ( | const int32 | areaIndex | ) | `[pure virtual]`

Returns a pointer to a Morph Area.

Parameters:

  | areaIndex,: | the index of the area

virtual EMorphMode MCCOMAPI I3DExVertexPrimitive::GetMorphMode | ( | boolean & | edit | ) | const`[pure virtual]`

Gets the current morph mode.

virtual EMorphTargetStorageType MCCOMAPI I3DExVertexPrimitive::GetMorphTargetStorageType | ( |  | ) | `[pure virtual]`

Returns how the morph targets are currently stored in the primitive (Compact or modeling) The morph targets are in compact mode when the object is not being edited in the modeler.

virtual void MCCOMAPI I3DExVertexPrimitive::GetMorphTargetUndoInfo | ( | IMorphTargetUndoInfo ** | undoInfo,
|  | const int32 | inMorphArea,
|  | const int32 | inTargets |
| ) |  |  | `[pure virtual]`

Returns the current state of the morph target to use to undo an operation performed on that morph target

Parameters:

  | undoInfo | The info info that is returned.
  | inMorphArea | The index of the morph area on which the operation is performed
  | inTarget | The index of the morph target in the morph area

virtual void MCCOMAPI I3DExVertexPrimitive::GetNamesForKind | ( | TMCArray< TMCString255 > & | nameList,
|  | int32 | kind |
| ) |  |  | `[pure virtual]`

virtual int32 MCCOMAPI I3DExVertexPrimitive::GetNbEdges | ( |  | ) | `[pure virtual]`

Returns the total number of edges in the primitive.

virtual int32 MCCOMAPI I3DExVertexPrimitive::GetNbFacets | ( |  | ) | `[pure virtual]`

virtual int32 MCCOMAPI I3DExVertexPrimitive::GetNbPolygons | ( |  | ) | `[pure virtual]`

virtual int32 MCCOMAPI I3DExVertexPrimitive::GetNbPolymeshes | ( |  | ) | `[pure virtual]`

Returns the number of Polymeshes in the primitive.

virtual int32 MCCOMAPI I3DExVertexPrimitive::GetNbVertices | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::GetPMAP | ( | VMDataStruct & | data | ) | `[pure virtual]`

virtual IPolygon* MCCOMAPI I3DExVertexPrimitive::GetPolygonFromFacetIndex | ( | int16 | lodindex,
|  | int32 | index |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::GetPolymesh | ( | IPolymesh ** | polymesh,
|  | int32 | index |
| ) |  |  | `[pure virtual]`

virtual real32 MCCOMAPI I3DExVertexPrimitive::GetScalingFactor | ( |  | ) | const`[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::GetSelectedSkinInfo | ( | TMCClassArray< TVertexSkinInfo > & | skinInfos | ) | `[pure virtual]`

Copies the skining info of the selected vertices into the given array.

virtual TMCClassArray<UVSpaceInfo>& MCCOMAPI I3DExVertexPrimitive::GetShadingDomainInfos | ( |  | ) | `[pure virtual]`

Return a reference on the shading domain list of this primitive.

Returns:
  the reference

virtual I3dExSkinable* MCCOMAPI I3DExVertexPrimitive::GetSkinableInterface | ( |  | ) | `[pure virtual]`

Returns the skinable interface (supported by the vertex primitive)

virtual I3DExSkinningAlgorithm* MCCOMAPI I3DExVertexPrimitive::GetSkinningAlgorithm | ( |  | ) | `[pure virtual]`

Gets the skinning algorithm used on the vertex primitive.

virtual SVPStatus* MCCOMAPI I3DExVertexPrimitive::GetStatus | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::GetUVBoundingBox | ( | TBBox2D & | bbox,
|  | boolean | selection = `false` |
| ) |  |  | `[pure virtual]`

virtual const UVSpaceInfo* MCCOMAPI I3DExVertexPrimitive::GetUVSpaceInfoByID | ( | uint32 | uvSpaceID | ) | `[pure virtual]`

Returns the uv space info with the same id than the given one, or null if not found

Parameters:

  | uvSpaceID | the id of the uv space to find

virtual void MCCOMAPI I3DExVertexPrimitive::GetWorkingBoxInfo | ( | TWorkingBoxInfo & | outInfo | ) | const`[pure virtual]`

Gets the parameters of the working box. When undefined, returns negative values.

virtual boolean MCCOMAPI I3DExVertexPrimitive::HasRenderableEdges | ( |  | ) | `[pure virtual]`

virtual boolean MCCOMAPI I3DExVertexPrimitive::HasRenderablePolygons | ( |  | ) | `[pure virtual]`

virtual boolean MCCOMAPI I3DExVertexPrimitive::HasRenderableVertices | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::Hydrate | ( |  | ) | `[pure virtual]`

Called by the modeler when it is hydrated.

virtual boolean MCCOMAPI I3DExVertexPrimitive::ImportMorphTarget | ( | I3DExVertexPrimitive * | inSource,
|  | const TMorphIDList * | morphIDList |
| ) |  |  | `[pure virtual]`

Import a morph target form antoher vertex object.

Parameters:

  | inSource | The morph target datas.
  | morphIDList | Contains the id of the morph area and the id of the morph target

Returns:
  True if the operation could be performed

virtual void MCCOMAPI I3DExVertexPrimitive::InitMarquee | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::InvalidateMorphing | ( | const int32 | areaIndex | ) | `[pure virtual]`

Invalidate the morph data

Parameters:

  | areaIndex,: | Set to kAllMorphArea to invalidate all the areas, otherwise set to the area to be invalidate

virtual void MCCOMAPI I3DExVertexPrimitive::InvertSelection | ( | int32 | selectionFlag | ) | `[pure virtual]`

Invert the selection status of the polygons, edges and vertices ( depending ) of the selectionFlags

Parameters:

  | selectionFlag | kOFPolygon, kOFEdge, or kOFVertex.

virtual boolean MCCOMAPI I3DExVertexPrimitive::IsHydrated | ( |  | ) | const`[pure virtual]`

Returns true of the vertex primitive is hydrated.

virtual boolean MCCOMAPI I3DExVertexPrimitive::IsNewPrimitive | ( |  | ) | `[pure virtual]`

virtual ErrorCode MCCOMAPI I3DExVertexPrimitive::Loft | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::MakeVPAction | ( | IVPAction::EVPActionKind | kind,
|  | IVPAction ** | obj |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::MoveSphereOfAttraction | ( | TVector3 & | center | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::OffsetSelection | ( | TVector3 & | offset | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::OffsetSurface | ( | real | distance | ) | `[pure virtual]`

virtual ErrorCode MCCOMAPI I3DExVertexPrimitive::Organic | ( |  | ) | `[pure virtual]`

virtual int32 MCCOMAPI I3DExVertexPrimitive::Pick | ( | void ** | obj,
|  | int32 | flags,
|  | FatRay & | fatRay,
|  | TVector3 & | hitPosition |
| ) |  |  | `[pure virtual]`

virtual int32 MCCOMAPI I3DExVertexPrimitive::PickUV | ( | void ** | obj,
|  | TIndex2 & | index,
|  | const TVector2 & | position,
|  | real32 | raySize |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::PosCheck | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::PreBoolean | ( |  | ) | `[pure virtual]`

virtual IPolymesh* MCCOMAPI I3DExVertexPrimitive::PrepareRevolution | ( |  | ) | `[pure virtual]`

Should be called before using Revolution. Build the extra edges usable as rotation axis and store the current selection state

Returns:
  A pointer to the new polymesh countaining the new edges. It's up to the user to keep them or delete them after the rotation is done.

virtual void MCCOMAPI I3DExVertexPrimitive::ProjectEditedMorphFromSkinnedPosition | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::ProjectToPlane | ( | TVector3 & | position,
|  | TVector3 & | normal |
| ) |  |  | `[pure virtual]`

virtual boolean MCCOMAPI I3DExVertexPrimitive::RayHit | ( | const TVector3 & | origin,
|  | const TVector3 & | direction,
|  | TVector3 & | position,
|  | TVector3 & | normal,
|  | int32 & | polymeshIndex |
| ) |  |  | `[pure virtual]`

Returns the intersection of a ray with the geometry in the modeler. The normal returned is the normal the last time than StoreNormalsRayHit() was called. If it was not called then it is the current normal to the mesh.

Note that the normal is always smoothed.

True if there is an intersection, false otherwise.

Parameters:

  | origin | origin of the ray
  | direction | direction of the ray
  | position | origin of the ray
  | normal | smoothed normal at the hit point
  | polymeshIndex | index of the polymesh that is hit if any

virtual void MCCOMAPI I3DExVertexPrimitive::RemoveMorphAreas | ( | TMCArray< int32 > & | removedAreaIndexes | ) | `[pure virtual]`

Remove a list of areas.

WARNING: since we work with index ( and not with ID ), removing areas from the array will shift all the indexes of the following areas

Parameters:

  | removedAreaIndexes,: | the array of the area indexes to be removed

virtual boolean MCCOMAPI I3DExVertexPrimitive::RemoveMorphTarget | ( | const int32 | inMorphArea,
|  | const int32 | targetIndex |
| ) |  |  | `[pure virtual]`

Remove a morph target from a morph area.

WARNING: since we work with index ( and not with ID ), removing a target from the array will shift all the indexes of the following targets.

Parameters:

  | inMorphArea,: | the index of the area
  | targetIndex,: | the index

Returns:
  True if the operation could be performed

virtual void MCCOMAPI I3DExVertexPrimitive::RemoveShadingDomain | ( | const int32 | domainID,
|  | int32 | replaceBy = `-1` |
| ) |  |  | `[pure virtual]`

Removes a shading domain from the list, and change the reference to this domain in the polygon into another one.

Parameters:

  | domainID | The domain to be removed.
  | replaceBy | The new ID to be set on the polygon. If -1, the first avaible ID is used.

virtual void MCCOMAPI I3DExVertexPrimitive::RemoveSpecialVertex | ( | boolean | displayedOne = `true` | ) | `[pure virtual]`

Sets all the vertex flag 'special' to false

virtual void MCCOMAPI I3DExVertexPrimitive::Replicate | ( | SReplicate & | data | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::ResetPolymeshMarkers | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::Resize | ( | TVector3 & | scale | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::ReverseSelectionNormals | ( |  | ) | `[pure virtual]`

Flip the selected polygons and all the adjacents polygons ( to keep a smooth surface ).

virtual IPolymesh* MCCOMAPI I3DExVertexPrimitive::Revolution | ( | int32 | nSteps,
|  | real32 | tolerance |
| ) |  |  | `[pure virtual]`

Uses the selected polylines to build a new polymesh by rotating them nSteps time arround an axis defined by an edge countaining 2 non-displayed special vertices. This method keep intact the original polylines

Parameters:

  | nSteps | Number of sections
  | tolerance | Distance under which the points arround the axis are merged in 1 point on the axis

Returns:
  A pointer to the newly created polymesh

virtual void MCCOMAPI I3DExVertexPrimitive::Rotate | ( | real | angle,
|  | CoordAxes | axis |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::SetBackdropImage | ( | const TMCString & | filePath,
|  | uint16 | planeID |
| ) |  |  | `[pure virtual]`

Set a backdrop image on a plane

Parameters:

  | filePath | the full path of the image file
  | planeID | the id of the plane

virtual void MCCOMAPI I3DExVertexPrimitive::SetEditedMorphs | ( | const TMorphIDList & | inEditedMorphs | ) | `[pure virtual]`

Sets the list of morphs being edited.

virtual void MCCOMAPI I3DExVertexPrimitive::SetGlobalDeformerDefaultStrength | ( | int32 | deformerIndex,
|  | real32 | strength |
| ) |  |  | `[pure virtual]`

Sets the default strength of an attached global deformer.

virtual void MCCOMAPI I3DExVertexPrimitive::SetHidden | ( | boolean | value,
|  | ESelectType | selectType |
| ) |  |  | `[pure virtual]`

Hides or Reveals vertices. Possibility to hide the selected vertices (selectType == eSelect), the non selected vertices (selectType == eNonSelect) or all the vertices (selectType == eAll). Possibility to reveal the hidden vertices in different state: all selected (selectType == eSelect), all non selected (selectType == eNonSlect), or untouched, as they currently are (selectType == eAll).

Parameters:

  | value | True to hide, false to reveal
  | selectType | Selection option

virtual void MCCOMAPI I3DExVertexPrimitive::SetIsFigurePrimitive | ( | boolean | isFigurePrimitive | ) | `[pure virtual]`

Sets whether a vertex primitive is actually a figure.

virtual boolean MCCOMAPI I3DExVertexPrimitive::SetMarquee | ( | TMCArray< RayPlane > & | rayPlanes,
|  | int32 | marqueeMode |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::SetMorphAreaOnSelection | ( | const int32 | morphAreaIndex,
|  | TMCArray< int32 > & | removedAreas |
| ) |  |  | `[pure virtual]`

set a currently existing area on a selection of vertices. The comments for CreateMorphAreaOnSelection are also valid here.

Parameters:

  | morphAreaIndex,: | the index of the area.
  | removedAreas,: | an array of the indexes of the area that aren't used anymore by any vertex after the new one has been set.

virtual void MCCOMAPI I3DExVertexPrimitive::SetMorphMode | ( | EMorphMode | inMorphMode,
|  | boolean | edit |
| ) |  |  | `[pure virtual]`

Sets the current morph mode.

virtual void MCCOMAPI I3DExVertexPrimitive::SetNameOnSelection | ( | const TMCString & | name,
|  | int32 | kind |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::SetSelectedSkinInfo | ( | TMCClassArray< TVertexSkinInfo > & | skinInfos | ) | `[pure virtual]`

Copies the skining info from the given array into the selected vertices

virtual void MCCOMAPI I3DExVertexPrimitive::SetSelection | ( | boolean | selected | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::SetSelectionByMorphArea | ( | const int32 | morphAreaIndex,
|  | const boolean | select,
|  | const boolean | addToCurrentSelection |
| ) |  |  | `[pure virtual]`

Select or deselect all the vertices in an area

Parameters:

  | morphAreaIndex | the index of the area
  | select | true to select, false to deselect
  | addToCurrentSelection | set to true to keep the current selection unmodified (unless it's part of the morph area)

virtual void MCCOMAPI I3DExVertexPrimitive::SetSelectionByName | ( | boolean | selected,
|  | int32 | kind,
|  | int8 * | name |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::SetSelectionByShadingDomain | ( | int32 | id,
|  | boolean | select |
| ) |  |  | `[pure virtual]`

Select/deselect polygons based on their shading domain ID.

Parameters:

  | id | The shading domain ID
  | select | True: select, false: deselect

virtual void MCCOMAPI I3DExVertexPrimitive::SetSelectionShadingDomainID | ( | uint32 | ShadingDomainID | ) | `[pure virtual]`

Sets the current selection shading domain ID (== UVSpaceID) to the passed ShadingDomainID. If no shading domain exist with this ID, nothing is done.

Parameters:

  | ShadingDomainID | : the ID of the shading domain

virtual void MCCOMAPI I3DExVertexPrimitive::SetShowPolygons | ( | boolean | value | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::SetShowUVUnfoldInfoDifferentColor | ( | boolean | enable | ) | `[pure virtual]`

Set polymeshset flag to enable or disable seam and pinning points dissplay in a different color

virtual void MCCOMAPI I3DExVertexPrimitive::SetSize | ( | TVector3 & | scale | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::SetSkinningAlgorithmComponent | ( | IShComponent * | algorithm | ) | `[pure virtual]`

Sets the skinning algorithm to use on the vertex primitive

Parameters:

  | algorithm | The algorithm to use.

virtual void MCCOMAPI I3DExVertexPrimitive::SetSkinningValid | ( | boolean | valid | ) | `[pure virtual]`

Invalidates the mesh (eg when the weights have changed.

virtual void MCCOMAPI I3DExVertexPrimitive::SetSphereOfAttraction | ( | SSOAData & | data | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::SetUpdateFacetMeshColor | ( | boolean | enable | ) | `[pure virtual]`

Set polymeshset flag to enable or disable FacetMeshColor update

virtual boolean MCCOMAPI I3DExVertexPrimitive::SetUVMarquee | ( | const TBBox2D & | rect,
|  | int32 | marqueeMode |
| ) |  |  | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::SetWorkingBoxInfo | ( | const TWorkingBoxInfo & | inInfo | ) | `[pure virtual]`

Sets the parameters of the working box.

virtual void MCCOMAPI I3DExVertexPrimitive::SetWorkingBoxPlane | ( | IWorkingBoxPlane * | WBPlane | ) | `[pure virtual]`

Give the active working box plane to the primitive. Some tool need it ( extrusion )

Parameters:

  | WBPlane | The working box plane

virtual TVertexPrimSkinInfo* MCCOMAPI I3DExVertexPrimitive::ShouldApplySkinning | ( | boolean & | recomputeSkinning | ) | `[pure virtual]`

Return Vertex Primitive Skin Info

Parameters:

  | recomputeSkinning | is set to true if the Skinning need recomputing

virtual ErrorCode MCCOMAPI I3DExVertexPrimitive::SimpleExtrude | ( | real | distance,
|  | boolean | linkPolygons |
| ) |  |  | `[pure virtual]`

Perform an extrusion of the current selection along their normal. Sets linkPolygons to true to keep all the adjacents polygons together.

Parameters:

  | distance | Distance of extrusion
  | linkPolygons | True if the polygons should be kept attached.

virtual void MCCOMAPI I3DExVertexPrimitive::SkipWrapAlert | ( |  | ) | `[pure virtual]`

Set polymeshset skip flag for WrapAround conflict alert to true

virtual void MCCOMAPI I3DExVertexPrimitive::SmoothEdges | ( | boolean | byAngle,
|  | real | angle,
|  | boolean | includeNonSelectedEdges |
| ) |  |  | `[pure virtual]`

virtual I3DExVertex* MCCOMAPI I3DExVertexPrimitive::SpecialVertex | ( | boolean | displayedOne = `true` | ) | `[pure virtual]`

Returns the first vertex encountered having its flag 'special' set to true.

Returns:
  a pointer to the vertex

virtual void MCCOMAPI I3DExVertexPrimitive::StartEdgeTransfer | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::StorePMAP | ( | const VMDataStruct & | data | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::SubdivideSelection | ( |  | ) | `[pure virtual]`

Subdivide the current selection by first applying a triangulation, then building the midegdes vertices ( using the curvature of the surface to place them ) and finaly linking these new vertices.

virtual void MCCOMAPI I3DExVertexPrimitive::SwapSkinInfos | ( | TMCClassArray< TVertexSkinInfo > & | skinInfos | ) | `[pure virtual]`

Swaps the skining info between the given array and the selected vertices

virtual ErrorCode MCCOMAPI I3DExVertexPrimitive::Sweep | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI I3DExVertexPrimitive::SymmetrizeSelection | ( |  | ) | `[pure virtual]`

Symmetrize the selection on polymeshes that have the symmetrical modeleing enabled.

virtual void MCCOMAPI I3DExVertexPrimitive::TesselateSelection | ( | const ETesselateMode | mode | ) | `[pure virtual]`

Tesselates the current selection using the method passed in. NOTE: the tesselation doesn't use the curvature of the surface to build new vertices (SubdivideSelection does).

Parameters:

  | mode | The mode of tesselation to be used.

virtual void MCCOMAPI I3DExVertexPrimitive::TimeHasChanged | ( |  | ) | `[pure virtual]`

acts on selected polylines

virtual void MCCOMAPI I3DExVertexPrimitive::Triangulate | ( |  | ) | `[pure virtual]`

Triangulate the selected polygons

virtual void MCCOMAPI I3DExVertexPrimitive::UndoMorphTargetChange | ( | IMorphTargetUndoInfo * | iUndoInfo | ) | `[pure virtual]`

Undoes a change a morph target

Parameters:

  | undoInfo | The info info that is returned.

virtual void MCCOMAPI I3DExVertexPrimitive::UnfoldUV | ( | int32 | projectionAxis,
|  | int32 | uvPinningAxis |
| ) |  |  | `[pure virtual]`

If some of the polymeshes have selected parts, those polymeshes would be unfolded. Otherwise all polymeshes would be unfolded

Parameters:

  | projectionAxis | The projection axis (0 - X, 1 - Y, 2 - Z)
  | uvPinningAxis | The UV axis used for pinning (0 - U, 1 - V)

virtual void MCCOMAPI I3DExVertexPrimitive::Untriangulate | ( |  | ) | `[pure virtual]`

Untriangulate the selected polygons

virtual void MCCOMAPI I3DExVertexPrimitive::UpdatePolygonColors | ( | FacetMesh * | facetMesh,
|  | boolean | faceted,
|  | EFacetMeshType | meshType |
| ) |  |  | `[pure virtual]`

virtual boolean MCCOMAPI I3DExVertexPrimitive::Weld | ( | real | tolerance,
|  | boolean | alignOnly |
| ) |  |  | `[pure virtual]`

The documentation for this struct was generated from the following file:

- I3DExVertexPrimitive.h